<?php

namespace Drupal\Tests\search_api_opensearch\Kernel;

use Drupal\KernelTests\KernelTestBase;

/**
 * Tests the data types.
 *
 * @group search_api_opensearch
 */
class DataTypeTest extends KernelTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['search_api', 'search_api_opensearch'];

  /**
   * Tests the data types.
   */
  public function testHasObjectDataType() {
    /** @var \Drupal\search_api\DataType\DataTypePluginManager $manager */
    $manager = $this->container->get('plugin.manager.search_api.data_type');
    $definitions = $manager->getDefinitions();
    $this->assertArrayHasKey('object', $definitions);
    $definition = $definitions['object'];
    $this->assertEquals('object', $definition['id']);
    $this->assertEquals('search_api_opensearch', $definition['provider']);
  }

}
